#include <stdint.h>
#include <stdlib.h>

#include "periodic_tasks.h"
#include "system.h"

static double theta;

static double ref(double t)
{
  if (t < 20) return 0;

  return 1;
}

double c(void)
{
  return theta;
}

void *control_body(void *p)
{
  double dt = *(double *)p;
  struct periodic_task *t;
  double u, u1;
  const double kp = -3, kd = -3;
  int i;

  u = 0; u1 = 0;
  i = 0;
  t = start_periodic_timer(0, 1000000.0 * dt);
  u1 = position();
  while(1) {
    wait_next_activation(t);
    i++;
    u = position();
    theta = kp * (ref(dt * i) - u) - kd * (u - u1) / dt;
    u1 = u;
  }

  return NULL;
}

