#include <stdint.h>
#include <stdlib.h>
#include <math.h>

#include "control.h"
#include "periodic_tasks.h"
  
double r, r1;

static double f1(double theta)
{
  const double m = 0.11;
  const double g = 9.8;
  double r2;

  r2 = -m * g * sin(theta);

  return r2;
}

static double f(double r, double r1, double dt)
{
  return r + r1 * dt;
}

void *system_body(void *p)
{
  double dt = *(double *)p;
  struct periodic_task *t;
  double th;

  r = 1;
  r1 = 0;
  th = 0;
  t = start_periodic_timer(0, 1000000.0 * dt);
  while(1) {
    th = c();
    r1 = r1 + f1(th) * dt;
    r = f(r, r1, dt);
    wait_next_activation(t);
  }

  return NULL;
}

double position(void)
{
  return r;
}
